GNU bug report logs - #18808
tail: implement 'tail -r' as synonym for 'tac'

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: coreutils; Severity: wishlist; Reported by: Eric Blake <eblake@HIDDEN>; dated Thu, 23 Oct 2014 16:40:03 UTC; Maintainer for coreutils is bug-coreutils@HIDDEN.
Changed bug title to 'tail: implement 'tail -r' as synonym for 'tac'' from 'implement 'tail -r' as synonym for 'tac'' Request was from Assaf Gordon <assafgordon@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Severity set to 'wishlist' from 'normal' Request was from Assaf Gordon <assafgordon@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 18808 <at> debbugs.gnu.org:


Received: (at 18808) by debbugs.gnu.org; 24 Oct 2014 12:12:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 24 08:12:07 2014
Received: from localhost ([127.0.0.1]:33651 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Xhdix-0001QV-6P
	for submit <at> debbugs.gnu.org; Fri, 24 Oct 2014 08:12:07 -0400
Received: from mx1.redhat.com ([209.132.183.28]:46022)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eblake@HIDDEN>) id 1Xhdiu-0001QJ-J7
 for 18808 <at> debbugs.gnu.org; Fri, 24 Oct 2014 08:12:05 -0400
Received: from int-mx10.intmail.prod.int.phx2.redhat.com
 (int-mx10.intmail.prod.int.phx2.redhat.com [10.5.11.23])
 by mx1.redhat.com (8.14.4/8.14.4) with ESMTP id s9OCBuBb004477
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-GCM-SHA384 bits=256 verify=FAIL);
 Fri, 24 Oct 2014 08:11:56 -0400
Received: from [10.3.113.23] (ovpn-113-23.phx2.redhat.com [10.3.113.23])
 by int-mx10.intmail.prod.int.phx2.redhat.com (8.14.4/8.14.4) with ESMTP id
 s9OCBuLR023716; Fri, 24 Oct 2014 08:11:56 -0400
Message-ID: <544A420B.4090304@HIDDEN>
Date: Fri, 24 Oct 2014 06:11:55 -0600
From: Eric Blake <eblake@HIDDEN>
Organization: Red Hat, Inc.
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
 rv:31.0) Gecko/20100101 Thunderbird/31.2.0
MIME-Version: 1.0
To: Bernhard Voelker <mail@HIDDEN>, =?UTF-8?B?UMOhZHJhaWcgQnI=?=
 =?UTF-8?B?YWR5?= <P@HIDDEN>
Subject: Re: bug#18808: implement 'tail -r' as synonym for 'tac'
References: <54492F3E.1090503@HIDDEN>	<54493279.80408@HIDDEN>	<54494A72.6020202@HIDDEN>	<5449511A.7080101@HIDDEN>	<54497A2F.2050305@HIDDEN>	<544986AC.2090805@HIDDEN>
 <5449ED7F.2040405@HIDDEN>
In-Reply-To: <5449ED7F.2040405@HIDDEN>
OpenPGP: url=http://people.redhat.com/eblake/eblake.gpg
Content-Type: multipart/signed; micalg=pgp-sha256;
 protocol="application/pgp-signature";
 boundary="q9BAWXwmQc963tElDhO7EK9DgkCc6QMGB"
X-Scanned-By: MIMEDefang 2.68 on 10.5.11.23
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 18808
Cc: 18808 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.4 (------)

This is an OpenPGP/MIME signed message (RFC 4880 and 3156)
--q9BAWXwmQc963tElDhO7EK9DgkCc6QMGB
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

On 10/24/2014 12:11 AM, Bernhard Voelker wrote:
> On 10/24/2014 12:52 AM, Eric Blake wrote:
>> On 10/23/2014 03:59 PM, P=C3=A1draig Brady wrote:
>> [...].  So among existing POSIX-certified systems, 'tail -r' is
>> the more popular extension at the moment.
>>
>>> Saying that, I'm 50:50 for implementing `tail -r` for compat reasons.=

>>
>> Yes, this alone is reason enough to implement it in GNU, regardless of=

>> the direction POSIX takes.
>=20
> I'm also worried about such an extension.  'tail -r' might be a useful
> thing - when -r is the only option being used, but looking at all the
> other options GNU tail already got over the years, adding -r doesn't
> fit well.  You proposed to make -n available to tac and then jump into
> it from 'tail -r'.  Well, what about -c? --follow=3D{name|descriptor}?

Reject them both.  Solaris 'tail -r' rejects use with -c or -f; reverse
mode is strictly limited to lines of a text file, and is strictly
limited to the existing end of the file at the time the command starts.

> --retry, --pid=3DPID?  To make -r fit well into tail, we'd have to add
> every single feature of it to tac.  This sounds not like a good idea.

No, to support 'tail -r', we make it refuse to operate with any option
other than -n, because that is all the more other implementations do,
and all the more POSIX is considering to require.  At least, as our
first cut at an implementation.  We can add more option interactions
later over time if desired as extensions, but we are not required to add
them, especially if we cannot come up with good semantics for those
interactions.

> tail does a good job, and so does tac.  I'd almost prefer to fork+pipe
> internally instead, similar to what e.g. 'sort --compress-program=3DPRO=
G'
> does.

That's why my proposal is limited to just librar-ifying the tac.c code
and calling into it (no need to fork+pipe when we can just do the work
directly).


--=20
Eric Blake   eblake redhat com    +1-919-301-3266
Libvirt virtualization library http://libvirt.org


--q9BAWXwmQc963tElDhO7EK9DgkCc6QMGB
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: OpenPGP digital signature
Content-Disposition: attachment; filename="signature.asc"

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1
Comment: Public key at http://people.redhat.com/eblake/eblake.gpg

iQEcBAEBCAAGBQJUSkILAAoJEKeha0olJ0NqKJYH/2uBayT+sUu8PHSgFaCqV3xr
AAFRrVQPVaR0VDE9RcJDW6DbEV8/+qpoM+00oltewJjggddAvNyYEY3p3AJaNW78
fCKTtQ7SPgckMdO9+yilH60/jMEpMPWMiLelQRnDsweU6QXRm101TwIAuBfHkvAJ
57XkiMSaL5IFRNE335Qa6pd9eUmw3FxtFpnOfftmtUOUme5tLE2Dl3ygnZtx1JmJ
yBMt9qM3MirDDoI1HmUlYNmdBUz2ddPMxKzRIR8u/xwqXLjdgSkQhcd7ExVZp0aM
fbD9c4hL05I/HC6qIxa4ku9YjbQNT4SQ5wHwKT13VeCT9PuQsR8e+SIkjjjIhTg=
=B81U
-----END PGP SIGNATURE-----

--q9BAWXwmQc963tElDhO7EK9DgkCc6QMGB--




Information forwarded to bug-coreutils@HIDDEN:
bug#18808; Package coreutils. Full text available.

Message received at 18808 <at> debbugs.gnu.org:


Received: (at 18808) by debbugs.gnu.org; 24 Oct 2014 06:11:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 24 02:11:25 2014
Received: from localhost ([127.0.0.1]:33435 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XhY5s-0006YT-Qu
	for submit <at> debbugs.gnu.org; Fri, 24 Oct 2014 02:11:25 -0400
Received: from mout.kundenserver.de ([212.227.126.187]:54535)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <mail@HIDDEN>) id 1XhY5q-0006YD-5B
 for 18808 <at> debbugs.gnu.org; Fri, 24 Oct 2014 02:11:22 -0400
Received: from [192.168.1.10] (pD956529F.dip0.t-ipconnect.de [217.86.82.159])
 by mrelayeu.kundenserver.de (node=mreue007) with ESMTP (Nemesis)
 id 0Lf4Iu-1YRaCd2NlA-00ooBz; Fri, 24 Oct 2014 08:11:11 +0200
Message-ID: <5449ED7F.2040405@HIDDEN>
Date: Fri, 24 Oct 2014 08:11:11 +0200
From: Bernhard Voelker <mail@HIDDEN>
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
 rv:31.0) Gecko/20100101 Thunderbird/31.1.0
MIME-Version: 1.0
To: Eric Blake <eblake@HIDDEN>, =?UTF-8?B?UMOhZHJhaWcgQnJhZHk=?=
 <P@HIDDEN>
Subject: Re: bug#18808: implement 'tail -r' as synonym for 'tac'
References: <54492F3E.1090503@HIDDEN>
 <54493279.80408@HIDDEN>	<54494A72.6020202@HIDDEN>
 <5449511A.7080101@HIDDEN>	<54497A2F.2050305@HIDDEN>
 <544986AC.2090805@HIDDEN>
In-Reply-To: <544986AC.2090805@HIDDEN>
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Provags-ID: V02:K0:W0+GNXqebuQ1ycBmosxYYqVJ5zxN/ivuKltX4tSSB2T
 x/YEIWUtXqbt29KswVZLgHEvDZhr2+gLmu90ZUofq37xhNw79d
 O0V8hGJIZ5JgJJnabbkg1MHUccP7kFgrDe0lu/2R3YNH3vpy6h
 +tPhx/uWZF5ZEBOCGsdEN1UQtvAkACwr626cF1v1F9pC4CwrXU
 nCVPZIpHztJwyqjnDbgwfCBBfr27uHdal7CyfNQC75CZ9Obs1m
 HSVtOX1BZih17+nvkuKGqlFXNSZbgFhTvhQjApKpC/poSlU9b0
 ED7OmXUsAHtEIv9jO9QnJBV5zHA1gQr/1Xq+b3fO5CqZWdJ5oN
 3QhuobEZjNeQ+5Tj3KIYKB7JM9BAbnP8eI9RB0nq6
X-UI-Out-Filterresults: notjunk:1;
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 18808
Cc: 18808 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

On 10/24/2014 12:52 AM, Eric Blake wrote:
> On 10/23/2014 03:59 PM, Pádraig Brady wrote:
> [...].  So among existing POSIX-certified systems, 'tail -r' is
> the more popular extension at the moment.
> 
>> Saying that, I'm 50:50 for implementing `tail -r` for compat reasons.
> 
> Yes, this alone is reason enough to implement it in GNU, regardless of
> the direction POSIX takes.

I'm also worried about such an extension.  'tail -r' might be a useful
thing - when -r is the only option being used, but looking at all the
other options GNU tail already got over the years, adding -r doesn't
fit well.  You proposed to make -n available to tac and then jump into
it from 'tail -r'.  Well, what about -c? --follow={name|descriptor}?
--retry, --pid=PID?  To make -r fit well into tail, we'd have to add
every single feature of it to tac.  This sounds not like a good idea.
tail does a good job, and so does tac.  I'd almost prefer to fork+pipe
internally instead, similar to what e.g. 'sort --compress-program=PROG'
does.

Have a nice day,
Berny





Information forwarded to bug-coreutils@HIDDEN:
bug#18808; Package coreutils. Full text available.

Message received at 18808 <at> debbugs.gnu.org:


Received: (at 18808) by debbugs.gnu.org; 23 Oct 2014 22:52:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 23 18:52:34 2014
Received: from localhost ([127.0.0.1]:33348 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XhRFB-0003qi-OS
	for submit <at> debbugs.gnu.org; Thu, 23 Oct 2014 18:52:34 -0400
Received: from mx1.redhat.com ([209.132.183.28]:38135)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eblake@HIDDEN>) id 1XhRF9-0003qX-25
 for 18808 <at> debbugs.gnu.org; Thu, 23 Oct 2014 18:52:32 -0400
Received: from int-mx10.intmail.prod.int.phx2.redhat.com
 (int-mx10.intmail.prod.int.phx2.redhat.com [10.5.11.23])
 by mx1.redhat.com (8.14.4/8.14.4) with ESMTP id s9NMqT9D019569
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-GCM-SHA384 bits=256 verify=FAIL);
 Thu, 23 Oct 2014 18:52:29 -0400
Received: from [10.3.113.23] (ovpn-113-23.phx2.redhat.com [10.3.113.23])
 by int-mx10.intmail.prod.int.phx2.redhat.com (8.14.4/8.14.4) with ESMTP id
 s9NMqSf5026488; Thu, 23 Oct 2014 18:52:29 -0400
Message-ID: <544986AC.2090805@HIDDEN>
Date: Thu, 23 Oct 2014 16:52:28 -0600
From: Eric Blake <eblake@HIDDEN>
Organization: Red Hat, Inc.
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
 rv:31.0) Gecko/20100101 Thunderbird/31.2.0
MIME-Version: 1.0
To: =?UTF-8?B?UMOhZHJhaWcgQnJhZHk=?= <P@HIDDEN>
Subject: Re: bug#18808: implement 'tail -r' as synonym for 'tac'
References: <54492F3E.1090503@HIDDEN> <54493279.80408@HIDDEN>
 <54494A72.6020202@HIDDEN> <5449511A.7080101@HIDDEN>
 <54497A2F.2050305@HIDDEN>
In-Reply-To: <54497A2F.2050305@HIDDEN>
OpenPGP: url=http://people.redhat.com/eblake/eblake.gpg
Content-Type: multipart/signed; micalg=pgp-sha256;
 protocol="application/pgp-signature";
 boundary="qjGKi7SApNDebWiKLqrQ3KdqixSeVROxn"
X-Scanned-By: MIMEDefang 2.68 on 10.5.11.23
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 18808
Cc: 18808 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.4 (------)

This is an OpenPGP/MIME signed message (RFC 4880 and 3156)
--qjGKi7SApNDebWiKLqrQ3KdqixSeVROxn
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

On 10/23/2014 03:59 PM, P=C3=A1draig Brady wrote:
>> 1. more implementations already have 'tail -r' than 'tac'
>=20
> More implementations but definitely not more installations.
> POSIX should prefer the most popular interface in my biased opinion.

Hey, I like being biased towards free software, as well :)  Popularity
does have some impact when considering what to standardize, and the
Austin Group has been very good at considering GNU behavior to at least
ensure that new requirements in the standard do not conflict with GNU.

But to be pedantic, probably a majority of POSIX-certified installations
have 'tail -r' (maybe as many as 100%? 'tail -r' dates back to at least
1980, before POSIX was even a dream, and is on more flavors of Unix than
just Solaris) while very few POSIX-certified installations have 'tac'
(no one has yet certified a GNU/Linux platform, to my knowledge; and
while some POSIX systems like Solaris include various GNU tools in a
default installation, GNU tac doesn't tend to be one of them).

Sadly, even though many pieces of GNU software try hard to comply with
POSIX, no one has yet ironed out all the remaining warts to use GNU as a
POSIX-certified system (and it's not a trivial task; some of the warts
are embedded fairly deeply in the kernel, such as behavior of
unlink("symlink-to-dir/") being different than the current POSIX
requirements).  So among existing POSIX-certified systems, 'tail -r' is
the more popular extension at the moment.

> Saying that, I'm 50:50 for implementing `tail -r` for compat reasons.

Yes, this alone is reason enough to implement it in GNU, regardless of
the direction POSIX takes.

--=20
Eric Blake   eblake redhat com    +1-919-301-3266
Libvirt virtualization library http://libvirt.org


--qjGKi7SApNDebWiKLqrQ3KdqixSeVROxn
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: OpenPGP digital signature
Content-Disposition: attachment; filename="signature.asc"

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1
Comment: Public key at http://people.redhat.com/eblake/eblake.gpg

iQEcBAEBCAAGBQJUSYasAAoJEKeha0olJ0Nq480H/iuEpBdJcIDQSR6yQFfr0g0+
qTdzbiyXfAQCvCV35d8kcGzHmL6HPZ3wiCqDBXb36kyndpts0iatxlQm6NijUT1A
f4Uy4GIHpkzXOAm4aH8QjoVE1t+SwgiO+6KfbfMpTR15FsMg+3FYBSUN/+0wNzv4
5ZMNqzkvgFJvm0vW3GMfw4zfgr3A3am5Jg3jBs6zugbIUpcZfM0QUT4hvqKffJSW
yUqpX0KDRAvUOywWmbdL1QXPwQn6Jf5D6GnZEAgNFLQ9S4q64Pl/eg/a0Pq+wicw
VP7LrimxOP7JrA73zb+mrT2kdOpMXR+kxk1qoUDgislv7GLVBY0SnAVWaYAf+gU=
=C3xt
-----END PGP SIGNATURE-----

--qjGKi7SApNDebWiKLqrQ3KdqixSeVROxn--




Information forwarded to bug-coreutils@HIDDEN:
bug#18808; Package coreutils. Full text available.

Message received at 18808 <at> debbugs.gnu.org:


Received: (at 18808) by debbugs.gnu.org; 23 Oct 2014 21:59:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 23 17:59:21 2014
Received: from localhost ([127.0.0.1]:33338 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XhQPg-0002Vv-TK
	for submit <at> debbugs.gnu.org; Thu, 23 Oct 2014 17:59:21 -0400
Received: from mail1.vodafone.ie ([213.233.128.43]:38236)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <P@HIDDEN>) id 1XhQPe-0002Vf-Lj
 for 18808 <at> debbugs.gnu.org; Thu, 23 Oct 2014 17:59:19 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: ApUBALZ5SVRtTWsK/2dsb2JhbAANT4dAziqDIAKBJwGEfwEBAQMBIw8BRgULCw0BCgICBRYLAgIJAwIBAgFFBg0BBwEBG4gaDbJweJRZAQEBAQEBAQMBAQEBAQEBAQEZgSyOSwlYB4J3gVQFnw6GZIoXh3qBcQEjgSEBAQE
Received: from unknown (HELO [192.168.1.43]) ([109.77.107.10])
 by mail1.vodafone.ie with ESMTP; 23 Oct 2014 22:59:11 +0100
Message-ID: <54497A2F.2050305@HIDDEN>
Date: Thu, 23 Oct 2014 22:59:11 +0100
From: =?UTF-8?B?UMOhZHJhaWcgQnJhZHk=?= <P@HIDDEN>
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
 rv:17.0) Gecko/20130110 Thunderbird/17.0.2
MIME-Version: 1.0
To: Eric Blake <eblake@HIDDEN>
Subject: Re: bug#18808: implement 'tail -r' as synonym for 'tac'
References: <54492F3E.1090503@HIDDEN> <54493279.80408@HIDDEN>
 <54494A72.6020202@HIDDEN> <5449511A.7080101@HIDDEN>
In-Reply-To: <5449511A.7080101@HIDDEN>
X-Enigmail-Version: 1.6
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 18808
Cc: 18808 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

On 10/23/2014 08:03 PM, Eric Blake wrote:
> On 10/23/2014 12:35 PM, Pádraig Brady wrote:
>>
>> Now the only reason I see would be for compat with solaris and BSD.
>>
>> I don't think they should have included that functionality though
>> as there isn't much complementary with the other tail functions
>> (being incompat with -f for example) and so is better split out as a separate util.
> 
> Yeah, today's Austin Group call included a debate about whether
> standardizing 'tac' would be smarter than 'tail -r', but the consensus
> among those on the call was that since:

I understand these 3 arguments, though don't necessarily agree with any.

> 1. more implementations already have 'tail -r' than 'tac'

More implementations but definitely not more installations.
POSIX should prefer the most popular interface in my biased opinion.

> 2. standardizing new requirements to an existing utility is easier than
> adding a completely new utility (if only slightly, due to less paperwork)

meh, paperwork should not impact on interface

> 3. GNU code tends to be the most adaptable

True, though while pragmatic should also not dictate interface.

Saying that, I'm 50:50 for implementing `tail -r` for compat reasons.

> therefore, 'tail -r' won the vote, and the result of the meeting was an
> action to me to see how adaptable GNU really is, and whether we can
> indeed quickly implement 'tail -r'.
> 
>>
>> The only small advantage of integration is a tiny perf benefit
>> when specifying a number of lines, but really `tail -r -n$num $file`
>> is of minimal improvement over `tac $file | head -n$num`
>> (though would be better than `tail -n$num | tac` as it avoids buffering).
> 
> The fact that we DON'T have 'tac -n' is what intrigues me most; that's
> the one thing that 'tail -r -n' can do in a single process that GNU
> can't.  Of course, it is trivial to implement it by doing what tac has
> always done and then stop output after -n is exceeded, and easy on
> seekable files as well.  But on non-seekable files, it may lend to an
> interesting optimization where knowing that the output will be limited
> to n lines makes it easier to set up a rolling window of the most recent
> n lines seen rather than having to dump out to a temporary file when the
> file proves to be larger than the current hueristics of when tac stays
> in memory.

-n wouldn't really have any impact on that better implementation.
I.E. ideally we should have an adaptive buffer internally
that after 128KiB or so (the current io_blksize()) would
start buffering to file, irrespective of -n.
That would deal with large lines and large -n.
Generally such an adaptive switch is optimal in various utils,
to operate efficiently with small inputs, but scalably with large ones.

>> As a side note I see that solaris doesn't even support non seekable input mode
>> (though BSD does):
>>
>>   $ printf "%s\n" 1 2 3 | tail -r -2
>>   tail: cannot open input
> 
> Careful, which tail are you testing?  From your output, I'm guessing you
> are trying to open the file named './-2' rather than limiting -r to a
> line count.  We made several observations during the Austin Group that
> /usr/bin/tail and /usr/xpg4/bin/tail behave differently.
> 
> $ /usr/bin/tail -rc
> usage: tail [+/-[n][lbc][f]] [file]
>        tail [+/-[n][l][r|f]] [file]
> $ printf "%s\n" 1 2 3 | /usr/bin/tail -2r
> 3
> 2
> $ printf "%s\n" 1 2 3 | /usr/xpg4/bin/tail -r -n2
> 3
> 2
> $ printf "%s\n" 1 2 3 | /usr/xpg4/bin/tail -r -2
> 3
> 2

Ugh right, that's the case here too.
How confusing.

thanks,
Pádraig.




Information forwarded to bug-coreutils@HIDDEN:
bug#18808; Package coreutils. Full text available.

Message received at 18808 <at> debbugs.gnu.org:


Received: (at 18808) by debbugs.gnu.org; 23 Oct 2014 19:04:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 23 15:04:01 2014
Received: from localhost ([127.0.0.1]:33287 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XhNg0-0006Yf-Q2
	for submit <at> debbugs.gnu.org; Thu, 23 Oct 2014 15:04:01 -0400
Received: from mx1.redhat.com ([209.132.183.28]:29530)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eblake@HIDDEN>) id 1XhNfy-0006YV-0G
 for 18808 <at> debbugs.gnu.org; Thu, 23 Oct 2014 15:03:58 -0400
Received: from int-mx14.intmail.prod.int.phx2.redhat.com
 (int-mx14.intmail.prod.int.phx2.redhat.com [10.5.11.27])
 by mx1.redhat.com (8.14.4/8.14.4) with ESMTP id s9NJ3twX020863
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-GCM-SHA384 bits=256 verify=FAIL);
 Thu, 23 Oct 2014 15:03:55 -0400
Received: from [10.3.113.61] (ovpn-113-61.phx2.redhat.com [10.3.113.61])
 by int-mx14.intmail.prod.int.phx2.redhat.com (8.14.4/8.14.4) with ESMTP id
 s9NJ3sVr032163; Thu, 23 Oct 2014 15:03:54 -0400
Message-ID: <5449511A.7080101@HIDDEN>
Date: Thu, 23 Oct 2014 13:03:54 -0600
From: Eric Blake <eblake@HIDDEN>
Organization: Red Hat, Inc.
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
 rv:31.0) Gecko/20100101 Thunderbird/31.2.0
MIME-Version: 1.0
To: =?UTF-8?B?UMOhZHJhaWcgQnJhZHk=?= <P@HIDDEN>
Subject: Re: bug#18808: implement 'tail -r' as synonym for 'tac'
References: <54492F3E.1090503@HIDDEN> <54493279.80408@HIDDEN>
 <54494A72.6020202@HIDDEN>
In-Reply-To: <54494A72.6020202@HIDDEN>
OpenPGP: url=http://people.redhat.com/eblake/eblake.gpg
Content-Type: multipart/signed; micalg=pgp-sha256;
 protocol="application/pgp-signature";
 boundary="QLsbQOAg1NXNbdD7u6BufOD52o1HBq3Mf"
X-Scanned-By: MIMEDefang 2.68 on 10.5.11.27
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 18808
Cc: 18808 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.4 (------)

This is an OpenPGP/MIME signed message (RFC 4880 and 3156)
--QLsbQOAg1NXNbdD7u6BufOD52o1HBq3Mf
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

On 10/23/2014 12:35 PM, P=C3=A1draig Brady wrote:
>=20
> Now the only reason I see would be for compat with solaris and BSD.
>=20
> I don't think they should have included that functionality though
> as there isn't much complementary with the other tail functions
> (being incompat with -f for example) and so is better split out as a se=
parate util.

Yeah, today's Austin Group call included a debate about whether
standardizing 'tac' would be smarter than 'tail -r', but the consensus
among those on the call was that since:
1. more implementations already have 'tail -r' than 'tac'
2. standardizing new requirements to an existing utility is easier than
adding a completely new utility (if only slightly, due to less paperwork)=

3. GNU code tends to be the most adaptable

therefore, 'tail -r' won the vote, and the result of the meeting was an
action to me to see how adaptable GNU really is, and whether we can
indeed quickly implement 'tail -r'.

>=20
> The only small advantage of integration is a tiny perf benefit
> when specifying a number of lines, but really `tail -r -n$num $file`
> is of minimal improvement over `tac $file | head -n$num`
> (though would be better than `tail -n$num | tac` as it avoids buffering=
).

The fact that we DON'T have 'tac -n' is what intrigues me most; that's
the one thing that 'tail -r -n' can do in a single process that GNU
can't.  Of course, it is trivial to implement it by doing what tac has
always done and then stop output after -n is exceeded, and easy on
seekable files as well.  But on non-seekable files, it may lend to an
interesting optimization where knowing that the output will be limited
to n lines makes it easier to set up a rolling window of the most recent
n lines seen rather than having to dump out to a temporary file when the
file proves to be larger than the current hueristics of when tac stays
in memory.

>=20
> As a side note I see that solaris doesn't even support non seekable inp=
ut mode
> (though BSD does):
>=20
>   $ printf "%s\n" 1 2 3 | tail -r -2
>   tail: cannot open input

Careful, which tail are you testing?  From your output, I'm guessing you
are trying to open the file named './-2' rather than limiting -r to a
line count.  We made several observations during the Austin Group that
/usr/bin/tail and /usr/xpg4/bin/tail behave differently.

$ /usr/bin/tail -rc
usage: tail [+/-[n][lbc][f]] [file]
       tail [+/-[n][l][r|f]] [file]
$ printf "%s\n" 1 2 3 | /usr/bin/tail -2r
3
2
$ printf "%s\n" 1 2 3 | /usr/xpg4/bin/tail -r -n2
3
2
$ printf "%s\n" 1 2 3 | /usr/xpg4/bin/tail -r -2
3
2

Curiously, Solaris usage also has a bug, as this command line SHOULD be
supported, per the output:

$ printf "%s\n" 1 2 3 | /usr/xpg4/bin/tail -r -c2
usage: tail [-f|-r] [-c number | -n number] [file]
       tail [+/-[number][lbc][f]] [file]
       tail [+/-[number][l][r|f]] [file]

But since it is not supported, the POSIX proposal does not require it,
and therefore, we don't have to worry about it either :)


--=20
Eric Blake   eblake redhat com    +1-919-301-3266
Libvirt virtualization library http://libvirt.org


--QLsbQOAg1NXNbdD7u6BufOD52o1HBq3Mf
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: OpenPGP digital signature
Content-Disposition: attachment; filename="signature.asc"

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1
Comment: Public key at http://people.redhat.com/eblake/eblake.gpg

iQEcBAEBCAAGBQJUSVEaAAoJEKeha0olJ0NqFncH/A8useQnw+8mPiWjeH/fT0ca
JWs18XM6ZoWe7YuLtTQXKyWFrL0WeLfvO+VBmxrLuvHjj7B/FnQFx0ipPfdYxrxT
0MAZA9FrTOK76U21DFZBWKGdmHRp86LvQTh/9pYWDZcW6wlMtL+pb2XOPQKx6tk7
jdnWbXEumIFT//HTBUePJdVKue/siqKnWPAYTRiWyRwYvlGUl8mfOd5rSu9MK9EE
+giWP2Z7FCswqJoDIqJAjLrFDaRtMY/7/VPGi3hFiY/pO6tkYs527iO11lUTAFt7
Pp8Rdb+NxYgy4zM+hG5ZVfYAY2GQ2dr1XmOE8YT0FXZ8V3bbVorxeSo1F5HRzFo=
=mUy9
-----END PGP SIGNATURE-----

--QLsbQOAg1NXNbdD7u6BufOD52o1HBq3Mf--




Information forwarded to bug-coreutils@HIDDEN:
bug#18808; Package coreutils. Full text available.

Message received at 18808 <at> debbugs.gnu.org:


Received: (at 18808) by debbugs.gnu.org; 23 Oct 2014 18:35:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 23 14:35:45 2014
Received: from localhost ([127.0.0.1]:33264 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XhNEe-0005ny-8e
	for submit <at> debbugs.gnu.org; Thu, 23 Oct 2014 14:35:44 -0400
Received: from mail1.vodafone.ie ([213.233.128.43]:37864)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <P@HIDDEN>) id 1XhNEZ-0005nf-4k
 for 18808 <at> debbugs.gnu.org; Thu, 23 Oct 2014 14:35:40 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: ApgBAKtJSVRtTWsK/2dsb2JhbAANNRqDYlmDBcl8h00CgSgBhQABAQQjDwFGEAsNAQoCAgUWCwICCQMCAQIBRQYNAQcBAYhCCDiyW3iUVQEBAQEBAQEDAQEBAQEBAQEBGYEsjmJKB4J3gVQFlkuIf4YokhFrgQiBQwEBAQ
Received: from unknown (HELO [192.168.1.43]) ([109.77.107.10])
 by mail1.vodafone.ie with ESMTP; 23 Oct 2014 19:35:31 +0100
Message-ID: <54494A72.6020202@HIDDEN>
Date: Thu, 23 Oct 2014 19:35:30 +0100
From: =?UTF-8?B?UMOhZHJhaWcgQnJhZHk=?= <P@HIDDEN>
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
 rv:17.0) Gecko/20130110 Thunderbird/17.0.2
MIME-Version: 1.0
To: Eric Blake <eblake@HIDDEN>
Subject: Re: bug#18808: implement 'tail -r' as synonym for 'tac'
References: <54492F3E.1090503@HIDDEN> <54493279.80408@HIDDEN>
In-Reply-To: <54493279.80408@HIDDEN>
X-Enigmail-Version: 1.6
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 18808
Cc: 18808 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

On 10/23/2014 05:53 PM, Eric Blake wrote:
> On 10/23/2014 10:39 AM, Eric Blake wrote:
>> POSIX is considering standardizing the Solaris/BSD behavior of 'tail -r'
>> rather than adding the GNU extension of 'tac' as a separate utility:
>> http://austingroupbugs.net/view.php?id=877
>>
>> This bug report serves as a reminder that we need to add 'tail -r'
>> support to coreutils, as well as a request for reviewers for the current
>> state of the proposal to make sure that it is not an onerous burden for
>> adding that code.
>>
> 
> Implementation-wise, I'm thinking the easiest thing might be to turn
> tac.c into a shared library-style file (similar to how copy.c is shared
> among multiple programs), add a 'tac -n' option that limits output to a
> fixed number of "lines" (or rather, a fixed number of occurrences of
> '--separator'-delimited segments), then have the new 'tail -r' call into
> the library code with separator hard-coded to newline, along with
> sufficient checks that tail's new -r can only be used with -n with no
> sign on the number (at least, as a first cut; we can certainly support
> more combinations than what POSIX wants to require, if we can determine
> sane semantics and easy implementations for those combinations).

The above approach sounds sensible if we were to do this.

Now the only reason I see would be for compat with solaris and BSD.

I don't think they should have included that functionality though
as there isn't much complementary with the other tail functions
(being incompat with -f for example) and so is better split out as a separate util.

The only small advantage of integration is a tiny perf benefit
when specifying a number of lines, but really `tail -r -n$num $file`
is of minimal improvement over `tac $file | head -n$num`
(though would be better than `tail -n$num | tac` as it avoids buffering).

As a side note I see that solaris doesn't even support non seekable input mode
(though BSD does):

  $ printf "%s\n" 1 2 3 | tail -r -2
  tail: cannot open input

Pádraig.




Information forwarded to bug-coreutils@HIDDEN:
bug#18808; Package coreutils. Full text available.

Message received at 18808 <at> debbugs.gnu.org:


Received: (at 18808) by debbugs.gnu.org; 23 Oct 2014 16:53:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 23 12:53:20 2014
Received: from localhost ([127.0.0.1]:33159 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XhLdY-00039O-7d
	for submit <at> debbugs.gnu.org; Thu, 23 Oct 2014 12:53:20 -0400
Received: from mx1.redhat.com ([209.132.183.28]:26882)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eblake@HIDDEN>) id 1XhLdV-00039C-27
 for 18808 <at> debbugs.gnu.org; Thu, 23 Oct 2014 12:53:17 -0400
Received: from int-mx14.intmail.prod.int.phx2.redhat.com
 (int-mx14.intmail.prod.int.phx2.redhat.com [10.5.11.27])
 by mx1.redhat.com (8.14.4/8.14.4) with ESMTP id s9NGrEZc029259
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-GCM-SHA384 bits=256 verify=FAIL)
 for <18808 <at> debbugs.gnu.org>; Thu, 23 Oct 2014 12:53:14 -0400
Received: from [10.3.113.61] (ovpn-113-61.phx2.redhat.com [10.3.113.61])
 by int-mx14.intmail.prod.int.phx2.redhat.com (8.14.4/8.14.4) with ESMTP id
 s9NGrDOg028090
 for <18808 <at> debbugs.gnu.org>; Thu, 23 Oct 2014 12:53:14 -0400
Message-ID: <54493279.80408@HIDDEN>
Date: Thu, 23 Oct 2014 10:53:13 -0600
From: Eric Blake <eblake@HIDDEN>
Organization: Red Hat, Inc.
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
 rv:31.0) Gecko/20100101 Thunderbird/31.2.0
MIME-Version: 1.0
To: 18808 <at> debbugs.gnu.org
Subject: Re: bug#18808: implement 'tail -r' as synonym for 'tac'
References: <54492F3E.1090503@HIDDEN>
In-Reply-To: <54492F3E.1090503@HIDDEN>
OpenPGP: url=http://people.redhat.com/eblake/eblake.gpg
Content-Type: multipart/signed; micalg=pgp-sha256;
 protocol="application/pgp-signature";
 boundary="UI9OF3L2EDP5ObXFUgdx6RCrakAui5Qkn"
X-Scanned-By: MIMEDefang 2.68 on 10.5.11.27
X-Spam-Score: -6.4 (------)
X-Debbugs-Envelope-To: 18808
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.4 (------)

This is an OpenPGP/MIME signed message (RFC 4880 and 3156)
--UI9OF3L2EDP5ObXFUgdx6RCrakAui5Qkn
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

On 10/23/2014 10:39 AM, Eric Blake wrote:
> POSIX is considering standardizing the Solaris/BSD behavior of 'tail -r=
'
> rather than adding the GNU extension of 'tac' as a separate utility:
> http://austingroupbugs.net/view.php?id=3D877
>=20
> This bug report serves as a reminder that we need to add 'tail -r'
> support to coreutils, as well as a request for reviewers for the curren=
t
> state of the proposal to make sure that it is not an onerous burden for=

> adding that code.
>=20

Implementation-wise, I'm thinking the easiest thing might be to turn
tac.c into a shared library-style file (similar to how copy.c is shared
among multiple programs), add a 'tac -n' option that limits output to a
fixed number of "lines" (or rather, a fixed number of occurrences of
'--separator'-delimited segments), then have the new 'tail -r' call into
the library code with separator hard-coded to newline, along with
sufficient checks that tail's new -r can only be used with -n with no
sign on the number (at least, as a first cut; we can certainly support
more combinations than what POSIX wants to require, if we can determine
sane semantics and easy implementations for those combinations).

--=20
Eric Blake   eblake redhat com    +1-919-301-3266
Libvirt virtualization library http://libvirt.org


--UI9OF3L2EDP5ObXFUgdx6RCrakAui5Qkn
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: OpenPGP digital signature
Content-Disposition: attachment; filename="signature.asc"

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1
Comment: Public key at http://people.redhat.com/eblake/eblake.gpg

iQEcBAEBCAAGBQJUSTJ5AAoJEKeha0olJ0NqvuAIAIKt3j90XdTSfPO+WU4JmptR
jXOg7BH83Ta1D9YMNS9ePgpD9xAhY2S9tOU3BbPtRjfiL3obEyTWrcHHpJQMaYNQ
mbLNxnFTWaTlXlNjugAHD9W887EXFF3vK6PjlZ27k55Gp3z+lA0WmRbYQtP3MiDq
1O2reUGxHgCOi2uWmkBF5Lsz5h3j8DWB8VkDfEfldvV44PAJscAT3d0FKDR1+Eln
AKhdtiiDl8WNcplAEyO/CXsZm6Y91HrWJFrNUs7+vFP69TEJ+4k6NKly/6FkKM9+
OPa2gdm8ANsIuM0Sbt7gzn8Ypp2xTkudddB4SSJUrJR07hZ057KuZjAW3ja51O4=
=p02M
-----END PGP SIGNATURE-----

--UI9OF3L2EDP5ObXFUgdx6RCrakAui5Qkn--




Information forwarded to bug-coreutils@HIDDEN:
bug#18808; Package coreutils. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Oct 2014 16:39:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 23 12:39:54 2014
Received: from localhost ([127.0.0.1]:33141 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1XhLQX-0002n2-Fu
	for submit <at> debbugs.gnu.org; Thu, 23 Oct 2014 12:39:53 -0400
Received: from eggs.gnu.org ([208.118.235.92]:53751)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eblake@HIDDEN>) id 1XhLQT-0002mj-AL
 for submit <at> debbugs.gnu.org; Thu, 23 Oct 2014 12:39:49 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eblake@HIDDEN>) id 1XhLQI-0001Jh-Tx
 for submit <at> debbugs.gnu.org; Thu, 23 Oct 2014 12:39:43 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00 autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:36989)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <eblake@HIDDEN>) id 1XhLQI-0001JZ-Qu
 for submit <at> debbugs.gnu.org; Thu, 23 Oct 2014 12:39:38 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:55417)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <eblake@HIDDEN>) id 1XhLQE-0005lV-9l
 for bug-coreutils@HIDDEN; Thu, 23 Oct 2014 12:39:38 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eblake@HIDDEN>) id 1XhLQ9-0001Fd-QJ
 for bug-coreutils@HIDDEN; Thu, 23 Oct 2014 12:39:34 -0400
Received: from mx1.redhat.com ([209.132.183.28]:3273)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <eblake@HIDDEN>) id 1XhLQ9-0001FG-IM
 for bug-coreutils@HIDDEN; Thu, 23 Oct 2014 12:39:29 -0400
Received: from int-mx14.intmail.prod.int.phx2.redhat.com
 (int-mx14.intmail.prod.int.phx2.redhat.com [10.5.11.27])
 by mx1.redhat.com (8.14.4/8.14.4) with ESMTP id s9NGdRtx007204
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-GCM-SHA384 bits=256 verify=FAIL)
 for <bug-coreutils@HIDDEN>; Thu, 23 Oct 2014 12:39:28 -0400
Received: from [10.3.113.61] (ovpn-113-61.phx2.redhat.com [10.3.113.61])
 by int-mx14.intmail.prod.int.phx2.redhat.com (8.14.4/8.14.4) with ESMTP id
 s9NGdQp9020701
 for <bug-coreutils@HIDDEN>; Thu, 23 Oct 2014 12:39:27 -0400
Message-ID: <54492F3E.1090503@HIDDEN>
Date: Thu, 23 Oct 2014 10:39:26 -0600
From: Eric Blake <eblake@HIDDEN>
Organization: Red Hat, Inc.
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
 rv:31.0) Gecko/20100101 Thunderbird/31.2.0
MIME-Version: 1.0
To: bug-coreutils@HIDDEN
Subject: implement 'tail -r' as synonym for 'tac'
OpenPGP: url=http://people.redhat.com/eblake/eblake.gpg
Content-Type: multipart/signed; micalg=pgp-sha256;
 protocol="application/pgp-signature";
 boundary="fqC71UgTVSFAnmpBROimDkO1JK2R9E18P"
X-Scanned-By: MIMEDefang 2.68 on 10.5.11.27
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 3.x
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

This is an OpenPGP/MIME signed message (RFC 4880 and 3156)
--fqC71UgTVSFAnmpBROimDkO1JK2R9E18P
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

POSIX is considering standardizing the Solaris/BSD behavior of 'tail -r'
rather than adding the GNU extension of 'tac' as a separate utility:
http://austingroupbugs.net/view.php?id=3D877

This bug report serves as a reminder that we need to add 'tail -r'
support to coreutils, as well as a request for reviewers for the current
state of the proposal to make sure that it is not an onerous burden for
adding that code.

--=20
Eric Blake   eblake redhat com    +1-919-301-3266
Libvirt virtualization library http://libvirt.org


--fqC71UgTVSFAnmpBROimDkO1JK2R9E18P
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: OpenPGP digital signature
Content-Disposition: attachment; filename="signature.asc"

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1
Comment: Public key at http://people.redhat.com/eblake/eblake.gpg

iQEcBAEBCAAGBQJUSS8+AAoJEKeha0olJ0NqFYoH/1PWXQIw7mV21J0myLruby5u
q6wJDUnrvlNU62+uzdDVHtFFJ9dsw79WzxLaUrh5v1ATWne190sHgZBd5R1j9Q18
51YVjKZto5pIzRZdi5IVR65lHn0lvnzMbWJwbI2HLGNqC3CiOp/oY2eOSo4MiHpF
XPp9LZpjo6/IRleOptDuQPGopRkeDQ8MPueZO6XHjb9kwnIUxbJ+nMuXm4vKxJsc
U7LdK7avVwNdsGjmh0vMTJTE9450WCjS0lZYkP9Ji+x+OBUbaYscCEdc9ggP870L
CHqEQXyQ6L0W3Q3dd/8iwm5GqxgVBNsUsmBIpEB0jV3gfIK1TbcO3nEs2qVGCJs=
=XNhK
-----END PGP SIGNATURE-----

--fqC71UgTVSFAnmpBROimDkO1JK2R9E18P--




Acknowledgement sent to Eric Blake <eblake@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-coreutils@HIDDEN. Full text available.
Report forwarded to bug-coreutils@HIDDEN:
bug#18808; Package coreutils. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 19 Oct 2018 01:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.